//
//  TestPlugin.m
//  PrefsPanePlugin
//
//  Created by Andreas on Mon Jun 09 2003.
//  Copyright (c) 2003 Andreas Mayer. All rights reserved.
//

#import "TestPlugin.h"

NSString *switch1 = @"switch1";

@implementation TestPlugin

- (id)initWithBundle:(NSBundle *)theBundle
{
	if (self = [super init]) {
		[self setBundle:theBundle];
		[self setDefaults:[NSUserDefaults standardUserDefaults]];
	}
	return self;
}

- (void)dealloc
{
	[bundle release];
	[defaults release];
	[super dealloc];
}

- (NSView *)loadMainView
{
	NSView *result = mainView;
	if (!nibLoaded) {
		NSString *nibFileName = @"TestPlugin";
		if ([NSBundle loadNibNamed:nibFileName owner:self]) {
			//NSLog(@"nib named %@ loaded", nibFileName);
			result = mainView;
			nibLoaded = YES;
		} else {
			NSLog(@"error loading nib named %@", nibFileName);
		}
	}
	return result;
}

- (NSView *)mainView
{
	return mainView;
}

- (NSBundle *)bundle
{
	return bundle;
}

- (void)setBundle:(NSBundle *)newBundle
{
	id old;

	if (newBundle != bundle) {
		old = bundle;
		bundle = [newBundle retain];
		[old release];
	}
}

- (NSUserDefaults *)defaults
{
    return defaults;
}

- (void)setDefaults:(NSUserDefaults *)newDefaults
{
    id old = nil;

    if (newDefaults != defaults) {
        old = defaults;
        defaults = [newDefaults retain];
        [old release];
    }
}

- (void)setRadioButtonValue:(id)sender
{
	[defaults setObject:[NSString stringWithFormat:@"%i", [[(NSMatrix *)sender selectedCell] tag]] forKey:@"radio1"];
}

- (void)setCheckBoxValue:(id)sender
{
	NSString *value;
	if ([(NSButton *)sender state] == NSOnState) {
		value = @"YES";
	} else {
		value = @"NO";
	}
	[defaults setObject:value forKey:switch1];
}

- (void)setSliderValue:(id)sender
{
	[defaults setObject:[NSString stringWithFormat:@"%i", [(NSSlider *)sender intValue]] forKey:@"slider1"];
}


- (void)willSelect
{
	[radioButtonMatrix selectCellWithTag:[[defaults objectForKey:@"radio1"] intValue]];
	[checkBox setState:([[defaults objectForKey:switch1] isEqualTo:@"YES"] ? NSOnState : NSOffState)];
	[checkBox setNeedsDisplay];
	[slider setIntValue:[[defaults objectForKey:@"slider1"] intValue]];
}

- (void)didSelect
{
}

- (void)willUnselect
{
}

- (void)didUnselect
{
	[defaults synchronize];
}


@end
