//
//  AMVersionNumber.h
//  TickerUpdate
//
//  Created by Andreas on 21.09.04.
//  Copyright 2004 Andreas Mayer. All rights reserved.
//

//	2007-01-06	Andreas Mayer
//	- added -stringValue (and -description)


#import <Cocoa/Cocoa.h>


// 1.2.3k8
// majorVersion: 1
// minorVersion: 2
// revision: 3
// build: "k"
// buildNumber: 8
// 4.5c3
// majorVersion: 4
// minorVersion: 5
// revision: 0
// build: "c"
// buildNumber: 3
// 1.0
// majorVersion: 1
// minorVersion: 0
// revision: 0
// build: ""
// buildNumber: 0

// alpha == α
// beta == β == ß
// alpha < beta < "" < {anything else}

@interface AMVersionNumber : NSObject {
	unsigned major;
	unsigned minor;
	unsigned revision;
	NSString *build;
	unsigned buildNumber;
}

+ (AMVersionNumber *)systemVersion;

+ (AMVersionNumber *)versionNumberWithString:(NSString *)versionString;

- (id)initWithMajor:(unsigned)major minor:(unsigned)minor revision:(unsigned)revision build:(NSString *)build buildNumber:(unsigned)number;

- (id)initWithString:(NSString *)versionString;

- (NSComparisonResult)compare:(id)otherVersion;

- (NSComparisonResult)compareToVersionNumber:(AMVersionNumber *)otherVersion;

- (BOOL)isEqualTo:(id)otherVersion;


- (NSString *)stringValue;

- (unsigned)majorVersion;
- (unsigned)minorVersion;
- (unsigned)revision;
- (NSString *)build;
- (unsigned)buildNumber;


@end
