//
//  NSFileManagerAMAdditions.m
//  CommX
//
//  Created by Andreas on Thu Jul 04 2002.
//  Copyright (c) 2002 Andreas Mayer. All rights reserved.
//
//	2004-09-18	Andreas Mayer
//	- leak in findSystemFolderType: fixed - thanks to Finlay Dobbie
//	2004-11-26	Andreas Mayer
//	- uniqueFileNameAtPath: added
//	2005-05-30	Andreas Mayer
//	- added -uniqueFileNameAtPath:delimiter:


#import "NSFileManagerAMAdditions.h"
#import <Carbon/Carbon.h>
//#include <CoreFoundation/CFURL.h>

//kUserDomain
//kApplicationSupportFolderType
//kCurrentUserFolderType


@implementation NSFileManager (AMAdditions)

/*
#if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_4)

+ (NSDictionary *)descriptionForDiskAtPath:(NSString *)path
{
	NSDictionary *result;
	DASessionRef session = DASessionCreate(kCFAllocatorDefault);
	DADiskRef diskRef = DADiskCreateFromBSDName(kCFAllocatorDefault, session, [path fileSystemRepresentation]);
	CFDictionaryRef dictionary = DADiskCopyDescription(diskRef);
	result = (NSDictionary *)dictionary;
	result = [[result retain] autorelease];
	if (session) CFRelease(session);
	if (diskRef) CFRelease(diskRef);
	if (dictionary) CFRelease(dictionary);
	return result;
}

#endif
*/

- (NSString *)findSystemFolderType:(int)folderType forDomain:(int)domain
{
	FSRef folder;
	OSErr err = noErr;
	CFURLRef url;
	NSString *result = nil;

	err = FSFindFolder(domain, folderType, false, &folder); 

	if (err == noErr) {
		url =  CFURLCreateFromFSRef(kCFAllocatorDefault, &folder);
		if (url != NULL) {
			result = [(NSURL *)url path];
			CFRelease(url);
		}
	}

	return result;
}

- (BOOL)redirectStandardErrorToPath:(NSString *)path
{
	return (freopen([path fileSystemRepresentation], (const char *)&"a+", (FILE *)[NSFileHandle fileHandleWithStandardError]) != NULL);
}

- (NSString *)uniqueFileNameAtPath:(NSString *)path delimiter:(NSString *)delimiter
{
	NSString *result = path;
	BOOL isDirectory;
	NSString *directory;
	NSString *filename;
	NSString *name;
	NSString *extension;
	BOOL fileExists = [self fileExistsAtPath:path isDirectory:&isDirectory];
	directory = [path stringByDeletingLastPathComponent];
	filename = [path lastPathComponent];
	name = [filename stringByDeletingPathExtension];
	extension = [filename pathExtension];
	int counter = 0;
	while (fileExists) {
		counter++;
		filename = [NSString stringWithFormat:@"%@%@%i", name, delimiter, counter];
		result = [directory stringByAppendingPathComponent:[filename stringByAppendingPathExtension:extension]];
		fileExists = [self fileExistsAtPath:result];
	}
	return result;
}

- (NSString *)uniqueFileNameAtPath:(NSString *)path
{
	return [self uniqueFileNameAtPath:path delimiter:@"-"];
}

- (BOOL)isVisibleFileAtPath:(NSString *)path
{
	BOOL result = YES;
	NSURL *url = [NSURL fileURLWithPath:path];
	LSItemInfoRecord itemInfo;
	if (LSCopyItemInfoForURL((CFURLRef)url, kLSRequestBasicFlagsOnly, &itemInfo) == noErr) {
		result = !(itemInfo.flags & kLSItemInfoIsInvisible);
	}
	return result;

//	BOOL result = NO;
//	if (![[path lastPathComponent] hasPrefix:@"."]) {
//		FSRef possibleInvisibleFile;
//		FSCatalogInfo catalogInfo;
//		OSStatus errStat = FSPathMakeRef([[path absolutePath] fileSystemRepresentation], &possibleInvisibleFile, nil);
//		FSGetCatalogInfo(&possibleInvisibleFile, kFSCatInfoFinderInfo, &catalogInfo, nil, nil, nil);
//		if (!((FileInfo*)catalogInfo.finderInfo)->finderFlags & kIsInvisible) {
//			NSString *hiddenFile = [NSString stringWithContentsOfFile:@"/.hidden"];
//			NSArray *dotHiddens = [hiddenFile componentsSeparatedByString:@"\n"];
//			result = (![dotHiddens containsObject:[self lastPathComponent]]);
//		}
//	}	
//	return result;
}


@end